/*
 * This file was automaticly generated by clo++ version 0.6.4 (REL-0_6_4)
 * http://pmade.org/pjones/software/clo++/
 */

/** @file
 * This file contains the implementation of the parser class.
 * You can control the name of this source file using the
 * cxx_source_file variable.
**/

#include "Options.h"
#include <cstring>
#include <cstdlib>
#include <cctype>

namespace {
    const char const_usage[] =
"  -i, --input string   input spline file\n"
"  -n, --num int        Number of points in the z and theta direction to\n"
"                       test. The default is 10\n"
"  -p, --prefix string  output prefix\n";

    const char const_help_comment[] =
"use the -h option for help";

    const char* expand_long_name (const std::string &name);
}

//#########################################################################
clo::parser::parser (void)
    : state_(state_option)
{
    std::memset(&locations_, 0, sizeof(locations_));
}
//#########################################################################
void clo::parser::parse (int argc, char *argv[], bool call_finalize) {
    for (int i=1; i<argc; ++i) parse_element(argv[i], i, source_cl);
    if (call_finalize) finalize();
}
//#########################################################################
void clo::parser::finalize (void) {
    if (state_ == state_value) {
	switch (openum_) {
	    case option_input:
		throw option_error("missing value for 'input' option");
	    case option_num:
		throw option_error("missing value for 'num' option");
	    case option_prefix:
		throw option_error("missing value for 'prefix' option");
	}

    }

    if (!locations_.input)
	throw option_error("the 'input' option is mandatory");

    if (!locations_.prefix)
	throw option_error("the 'prefix' option is mandatory");

}
//#########################################################################
void clo::parser::parse_element (const char *element, int position, opsource source) {
    std::size_t length = std::strlen(element);

    switch (state_) {
	case state_consume:
	    non_options_.push_back(element);
	    break;
	case state_option:
	    if (length >= 2 && element[0] == '-' && element[1] == '-') {
		if (length == 2) { state_ = state_consume; return; }
		element += 2;
		const char *value = element;
		while (*value != 0 && *value != '=') ++value;
		if (*value == '=') {
		    std::string selement(element, value - element), svalue(++value);

		    parse_long_option(selement.c_str(), position, source);
		    if (state_ != state_value) {
			std::string error("the '"); error += element; error += "' option does not take a value";
			throw option_error(error);
		    }

		    parse_value(svalue.c_str());
		    state_ = state_option;
		} else {
		    parse_long_option(element, position, source);
		}
	    } else if (length >= 2 && element[0] == '-') {
		++element;

		if (length > 2) {
		    while (*element != 0) {
			parse_short_option(*element, position, source);
			++element;
	    
			if (state_ == state_value && *element != 0) {
			    parse_value(element);
			    state_ = state_option;
			    break;
			}
		    }
		} else {
		    parse_short_option(*element, position, source);
		}
	    } else {
		non_options_.push_back(element);
	    }
	    break;
	case state_value:
	    parse_value(element);
	    state_ = state_option;
	    break;
    }
}
//#########################################################################
void clo::parser::parse_short_option (char option, int position, opsource source) {
    switch (option) {
    	case 'i':
    	    source = source; // kill compiler unused variable warning
    	    if (locations_.input) {
    		throw option_error("the 'input' option is only allowed once");
    	    }
    	    openum_ = option_input;
    	    state_ = state_value;
    	    locations_.input = position;
    	    return;
    	case 'n':
    	    source = source; // kill compiler unused variable warning
    	    openum_ = option_num;
    	    state_ = state_value;
    	    locations_.num = position;
    	    return;
    	case 'p':
    	    source = source; // kill compiler unused variable warning
    	    if (locations_.prefix) {
    		throw option_error("the 'prefix' option is only allowed once");
    	    }
    	    openum_ = option_prefix;
    	    state_ = state_value;
    	    locations_.prefix = position;
    	    return;
    	case 'h':
    	    if (source != source_cl) break;
    	    throw autoexcept(autothrow_help, const_usage);
    	case '?':
    	    if (source != source_cl) break;
    	    throw autoexcept(autothrow_help, const_usage);
    }

    std::string error("unknown option: '"); error += option; error += "'";
    throw option_error(error);
}
//#########################################################################
void clo::parser::parse_long_option (const char *option, int position, opsource source) {
    option = expand_long_name(option);

	    if (std::strcmp(option, "input") == 0) {
		source = source; // kill compiler unused variable warning
		if (locations_.input) {
		    throw option_error("the 'input' option is only allowed once");
		}
		openum_ = option_input;
		locations_.input = position;
		state_ = state_value;
		return;
	    } else if (std::strcmp(option, "num") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_num;
		locations_.num = position;
		state_ = state_value;
		return;
	    } else if (std::strcmp(option, "prefix") == 0) {
		source = source; // kill compiler unused variable warning
		if (locations_.prefix) {
		    throw option_error("the 'prefix' option is only allowed once");
		}
		openum_ = option_prefix;
		locations_.prefix = position;
		state_ = state_value;
		return;
	    } else if (source == source_cl && std::strcmp(option, "help") == 0) {
		throw autoexcept(autothrow_help, const_usage);
	    }

    std::string error("unknown option '"); error += option; error += "'";
    throw option_error(error);
}
//#########################################################################
void clo::parser::parse_value (const char *value) {
    switch (openum_) {
    	case option_input:
    	    {
    		options_.input = value;
    	    }
    	    break;
    	case option_num:
    	    {
    		char *endptr; int tmp = std::strtol(value, &endptr, 0);
    		while (*endptr != 0 && std::isspace(*endptr)) ++endptr;

    		if (*endptr != 0) {
    		    std::string error("invalid integer value '"); error += value; error += "'";
    		    throw option_error(error);
    		}

    		if (tmp < 0) {
    		    throw option_error("integer value out of range, 'num' min is 0");
    		}

    		options_.num = tmp;
    	    }
    	    break;
    	case option_prefix:
    	    {
    		options_.prefix = value;
    	    }
    	    break;
    }
}
//#########################################################################
const char* clo::option_error::get_help_comment (void) const {
    return const_help_comment;
}
//#########################################################################
namespace {
    const char* expand_long_name (const std::string &name) {
	std::string::size_type name_size = name.size();
	std::vector<const char*> matches;

        if (name_size <= 5 && name.compare(0, name_size, "input", name_size) == 0)
        	matches.push_back("input");

        if (name_size <= 3 && name.compare(0, name_size, "num", name_size) == 0)
        	matches.push_back("num");

        if (name_size <= 6 && name.compare(0, name_size, "prefix", name_size) == 0)
        	matches.push_back("prefix");

        if (name_size <= 4 && name.compare(0, name_size, "help", name_size) == 0)
        	matches.push_back("help");


	if (matches.empty()) {
	    std::string error("unknown option '"); error += name; error += "'";
	    throw clo::option_error(error);
	}

	if (matches.size() == 1) {
	    return matches[0];
	}

	std::string error("the option name '"); error += name; error += "' is ambiguous";
	throw clo::option_error(error);
    }
} // end anonymous namespace
