#include <stdio.h>
#include <stdlib.h>
#include <libgen.h>

#include <Exception/Exception.h>

#include "main.h"
#include "Options.h"

void usage( void );
void gparam( Common *c, clo::parser& parser );

int
main(int argc, char *argv[]) {

  try {

    Common c;

    c.prgname = argv[0];

    /*
     * create a command line parser class and then tell it to parse your
     * command line.
     */
    clo::parser parser;

    parser.parse( argc, argv );

    gparam(&c, parser );

    return process(&c);

  }  catch ( clo::autoexcept & cloa ) {

    switch( cloa.get_autothrow_id( ) ) {
      
    case clo::autothrow_help:
      std::cout << "Usage: " << basename( argv[0] ) << " [options]\n";
      std::cout << cloa.what();
      return EXIT_SUCCESS;
    }


  } catch( std::exception &e ) {

    std::cerr << e.what() << "\n";
    return EXIT_FAILURE;

  } catch ( ... ) {

    cerr << "Unknown exception caught, got to love C++\n";
    return EXIT_FAILURE;

  }

}

